<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Fundamentals of version control written tutorial</title>
  <style>
    html {
      line-height: 1.5;
      font-family: Georgia, serif;
      font-size: 20px;
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      overflow-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 1em;
      }
    }
    @media print {
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, 'Lucida Console', Consolas, monospace;
      font-size: 85%;
      margin: 0;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
      overflow-wrap: normal;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>
<body>
<header id="title-block-header">
<h1 class="title">Fundamentals of version control written tutorial</h1>
</header>
<nav id="TOC" role="doc-toc">
<ul>
<li><a href="#the-case-study">The case study</a></li>
<li><a href="#description-of-the-folder-and-files">Description of the folder and files</a></li>
<li><a href="#work-on-the-project">Work on the project</a>
<ul>
<li><a href="#start-a-repo">Start a repo</a>
<ul>
<li><a href="#first-steps">First steps</a></li>
</ul></li>
<li><a href="#the-workflow">The workflow</a>
<ul>
<li><a href="#the-first-commit">The first commit</a></li>
<li><a href="#checking-the-history">Checking the history</a></li>
<li><a href="#connect-to-a-remote-repository">Connect to a remote repository</a></li>
</ul></li>
<li><a href="#lets-write-the-manuscript">Let’s write the manuscript</a>
<ul>
<li><a href="#creating-branches">Creating branches</a></li>
<li><a href="#evaluate-differences">Evaluate differences</a></li>
<li><a href="#reverting-a-mistake">Reverting a mistake</a></li>
</ul></li>
<li><a href="#putting-things-together">Putting things together</a></li>
</ul></li>
<li><a href="#conclusions">Conclusions</a></li>
</ul>
</nav>
<p>In this tutorial we are going through the basics of version control with Git and Gitlab. We will discuss how to set up a sustainable and correct workflow, how to create a final product that is completely version controlled while being able to go back and forth between different <strong>versions</strong>, correcting <strong>mistakes</strong> and compare <strong>features</strong>.</p>
<h2 id="the-case-study">The case study</h2>
<p>For this tutorial we are going to make a <em>“mock”</em> manuscript that could be used for a publication combining <strong>LaTeX</strong> for the creation of the document and <strong>Python</strong> for the generation of some mock data and a figure.</p>
<p>Below you can find:</p>
<ul>
<li>The <a href="https://mvgroup.gitlab.io/version_control_tutorial/docs/presentation/">presentation</a> associated with this tutorial.</li>
<li>The <a href="https://gitlab.com/mvgroup/version_control_tutorial/-/tree/main/">Gitlab repository</a> for our course on version control.</li>
</ul>
<h2 id="description-of-the-folder-and-files">Description of the folder and files</h2>
<ul>
<li>Manuscript/<strong>manuscript.tex</strong> -&gt; main file for the production of the final manuscript. Compile it to obtain the final PDF.</li>
<li>Manuscript/<strong>figures</strong> -&gt; folder where images and figures to include in the manuscript are stored. In this case the figure is generated from Python and saved directly in this directory.</li>
<li><strong>python_script.py</strong> -&gt; example Python script that creates some synthetic data and generates a figure to include in the manuscript.</li>
</ul>
<h1 id="work-on-the-project">Work on the project</h1>
<h2 id="start-a-repo">Start a repo</h2>
<p>The first step in starting out project is to start a version-controlled directory or a <strong>repository</strong> (<em>repo</em> in short).</p>
<p>There are two ways to start a repo:</p>
<ol type="1">
<li>Starting it from scratch (locally), and connecting it to a remote repo</li>
<li>Cloning an already-existing remote repo to your local computer</li>
</ol>
<p>We can start a repo from scratch with the command:</p>
<pre><code>git init</code></pre>
<p>Alternatively, you can clone an existing remote repo by using the command:</p>
<pre><code>git clone https://gitlab.com/mv_group/version_control_tutorial.git</code></pre>
<p>You will likely use this method if you want to contribute to another colleague’s work or if someone else created the repository already and you need to work on it. In this tutorial we are going to assume you want to <strong>work mostly independently</strong> and so you will start from scratch in your local machine.</p>
<p>Note that both methods will create a version-controlled folder with Git in the background controlling <strong>all the contents and versions at all times</strong>.</p>
<h3 id="first-steps">First steps</h3>
<p>It’s very important to always include a <strong>descriptive</strong> <em>Readme file</em> in your repository, to present to you and others what the repository is for and what are its contents. Together with that let’s start all the files we will need for our project.</p>
<p>After I created the folders and the files that I will need for my manuscript.</p>
<pre><code>$ git init
Initialized empty Git repository in path_to/manuscript_repo/.git/

$ git status
On branch main

No commits yet

Untracked files:
  (use &quot;git add &lt;file&gt;...&quot; to include in what will be committed)
        Readme.md
        manuscript.tex
        python_script.py

nothing added to commit but untracked files present (use &quot;git add&quot; to track)</code></pre>
<p>As you can see, Git recognized <strong>we have created a new repo</strong> and that this folder has <strong>new untracked files</strong>.</p>
<h2 id="the-workflow">The workflow</h2>
<p>Everything with Git is divided in <strong>branches</strong>. Git branches, like tree branches, they start from the main “stalk”, and grow outwards. Typically, each branch contains a <strong>feature</strong> that is <em>different or independent enough</em> from the main project that can be treated separately.</p>
<p>By default the main “stalk” or branch in Git is called the <strong>main branch</strong>. You will see this name popup every here and there.</p>
<h3 id="the-first-commit">The first commit</h3>
<p>So far we have created the new files but we haven’t yet told Git to “save” the “status” or <em>version</em> of these files for future reference. This is called a <strong>commit</strong>. So let’s do our first commit to jumpstart our project.</p>
<pre><code>$ git add .

$ git commit -m &quot;first commit to start repository&quot;
[main (root-commit) c314709] first commit to start repository
 3 files changed, 1 insertion(+)
 create mode 100644 Readme.md
 create mode 100644 manuscript.tex
 create mode 100644 python_script.py

$ git status
On branch main
nothing to commit, working tree clean</code></pre>
<p>The first command will add all your new files to the <strong>staging area</strong>, a place where the files are ready to be commited. The second command will <em>commit</em> the versions of added files to the version control memory associating them with a <em>message</em> in quotation.</p>
<p>This messages are <strong>mandatory</strong> and are crucial to keep order and to help yourself remember what was done in each commit. It is easier to remember and understand the history of your workflow if you documented well your commits with clever use of the commit messages.</p>
<h3 id="checking-the-history">Checking the history</h3>
<p>Whenever you are lost, you don’t remember the history of the project, or simply you need to find out when you did what, you can resort to the Git log. It will inform you on all commits executed in this repo, with date, time, author information and commit messages.</p>
<pre><code>$ git log
commit c314709dd31feadbc0e091d5f62286a279992fc5 (HEAD -&gt; main)
Author: marcodallavecchia &lt;marcodv93@gmail.com&gt;
Date:   Sat Jul 24 16:47:35 2021 +0200

    first commit to start repository</code></pre>
<p>It is very important that through this tutorial you will get familiar with the different Git outputs and what some of the terms mean. A term you will find often is HEAD, a pointer to the <strong>current branch reference</strong>, in this case the current status of your repo. Another important thing to realize is that each commit is defined by a very long hash code, that <strong>uniquely identify a commit from any other</strong>. You can see that long code for my first commit in the section above.</p>
<h3 id="connect-to-a-remote-repository">Connect to a remote repository</h3>
<p>So far we have only worked locally. This means that although all our files inside the repo are version-controlled, the project is not online and is not accessible by anyone else that is not at your computer. To do so we will now see how you can push your repository to a Git manager such as Gitlab.</p>
<ol type="1">
<li>On <a href="https://gitlab.com/gitlab-com">gitlab.com</a>, login with your account and create a new project.</li>
<li>Following the Blue Clone button or the instructions below find the SSH or HTTPS address for this new repository.</li>
<li>Establish the connection between the local and the remote repo by adding the origin (the remote address) to Git</li>
</ol>
<pre><code>$ git remote add origin git@gitlab.com:marcodv93/manuscript_repo.git</code></pre>
<ol start="4" type="1">
<li>Push your repository status to the newly-added remote repository</li>
</ol>
<pre><code>$ git push -u origin main</code></pre>
<h2 id="lets-write-the-manuscript">Let’s write the manuscript</h2>
<p>Usually a manuscript for a publication is divided in many sections, but for simplicity in our case we will only have an <em>abstract</em>, an <em>introduction</em> and a <em>results and discussion</em> sections.</p>
<p>A clever way to see these sections is to consider them as <strong>separated features</strong>, meaning that when working on one of these sections we won’t work on the others as they are <em>independent</em>. This is a very good practice because it prevents clashing of content when working together with collaborators or even when you work by yourself on different sections at different times.</p>
<h3 id="creating-branches">Creating branches</h3>
<p>Whenever we can identify independent features that can benefit from separate development we can create a new branch. This branch will continue developing until is completed, in this way the main branch doesn’t have to be changed or update, until the parallel features are completed. This will keep the main branch <strong>clean and organized.</strong></p>
<p>In this case, we will create and move to a new branch and we will work, add, and commit on that branch alone.</p>
<pre><code>$ git branch manuscript_abstract

$ git checkout manuscript_abstract
Switched to branch &#39;manuscript_abstract&#39;

$ git status
On branch manuscript_abstract
Changes not staged for commit:
  (use &quot;git add &lt;file&gt;...&quot; to update what will be committed)
  (use &quot;git restore &lt;file&gt;...&quot; to discard changes in working directory)
        modified:   manuscript.tex

no changes added to commit (use &quot;git add&quot; and/or &quot;git commit -a&quot;)

$ git add .

$ git commit -m &quot;added abstract to manuscript&quot;
[manuscript_abstract c73ed52] added abstract to manuscript
 1 file changed, 23 insertions(+)</code></pre>
<p>As you can see, we have created an abstract-specific branch, modified the manuscript.tex file with the abstract, then proceed with the usual workflow: adding and commiting. If we also want to push this commit to the remote repository, we should create a remote branch as well by doing:</p>
<pre><code>$ git push origin manuscript_abstract</code></pre>
<p>To remember well let’s try to do a similar thing for the results and discussion section of our manuscript:</p>
<pre><code>$ git checkout main
Switched to branch &#39;main&#39;

$ git branch manuscript_results_discussion

$ git checkout manuscript_results_discussion
Switched to branch &#39;manuscript_results_discussion&#39;
$ git status

On branch manuscript_results_discussion
Changes not staged for commit:
  (use &quot;git add &lt;file&gt;...&quot; to update what will be committed)
  (use &quot;git restore &lt;file&gt;...&quot; to discard changes in working directory)
        modified:   manuscript.tex

no changes added to commit (use &quot;git add&quot; and/or &quot;git commit -a&quot;)

$ git add .

$ git commit -m &quot;&quot;added results and discussion section to manuscript&quot;
[manuscript_results_discussion a8b1da2] added results and discussion section to manuscript
 1 file changed, 23 insertions(+)</code></pre>
<p>Once you have several branches at the same time you can always check the Git log for a specific branch by:</p>
<pre><code>$ git log manuscript_abstract
commit c73ed52507d092acfe358c92b7d0b3e1b6c6d6af (manuscript_abstract)
Author: marcodallavecchia &lt;marcodv93@gmail.com&gt;
Date:   Sat Jul 24 17:34:59 2021 +0200

    added abstract to manuscript

commit c314709dd31feadbc0e091d5f62286a279992fc5 (main)
Author: marcodallavecchia &lt;marcodv93@gmail.com&gt;
Date:   Sat Jul 24 16:47:35 2021 +0200

    first commit to start repository</code></pre>
<h3 id="evaluate-differences">Evaluate differences</h3>
<p>Let’s now say that you have done many commits in possibly different branches and your project is starting to increase in volume. Yes you can always use Git log to check the commit messages to keep track of what you did but sometimes you forget the details and <strong>you want to check exactly what the differences are between two different versions of a file</strong>.</p>
<p>In my case, while I was working on the python_script.py file I modified my plot to make it look prettier but now I forgot what color it was originally. Let’s see how I could check my version chronology to verify what the differences are between my current version and a previous one.</p>
<p>For this task, having the hash code for the commits you want to compare is useful, so you can add the <em>oneline</em> option to the Git log for a brief summary.</p>
<pre><code>$ git log --oneline
9740466 (HEAD -&gt; main) modified color and marker size
2d429c5 modified python script
c314709 first commit to start repository

$ git diff HEAD 2d429c5
diff --git a/python_script.py b/python_script.py
index 17c3842..1bd034d 100644
--- a/python_script.py
+++ b/python_script.py
@@ -38,7 +38,7 @@ ax[0].set_xlabel(&quot;Y&quot;)
 ax[0].set_ylabel(&quot;counts&quot;)
 ax[0].grid()

-ax[1].scatter(df[&quot;X&quot;], df[&quot;Y&quot;], c = &quot;purple&quot;, s = 90, marker = &quot;*&quot;)
+ax[1].scatter(df[&quot;X&quot;], df[&quot;Y&quot;], c = &quot;blue&quot;, s = 50, marker = &quot;*&quot;)
 ax[1].grid()
 ax[1].set_ylabel(&quot;Y&quot;)
 ax[1].set_xlabel(&quot;X&quot;)</code></pre>
<p>What I did here is to use the Git diff command to compare my current status of the directory (HEAD by default) to a previous commit (hash code starts with 2d429c5). What did I learn? It turns out I used to have the color of my plot to purple and my marker size at 90 but I later changed the color to blue and the size to 50. You can learn more about the Git diff output <a href="https://www.atlassian.com/git/tutorials/saving-changes/git-diff">here</a>.</p>
<p>As a tip you can also use the following syntax if you don’t want to use the absolute hash code of the commit.</p>
<pre><code>$ git diff HEAD~1</code></pre>
<p>Git diff is even more powerful that what we have seen so far. For example I can even check the difference between two branches like this:</p>
<pre><code>$ git diff manuscript_abstract manuscript_results_discussion
diff --git a/manuscript.tex b/manuscript.tex
index 30875d8..54ea9d6 100644
--- a/manuscript.tex
+++ b/manuscript.tex
@@ -15,9 +15,9 @@

 \maketitle

-\begin{abstract}
-This is a beautiful and descriptive abstract
-\end{abstract}
+\section{Results and Discussion}
+THESE ARE SOME BEAUTIFUL RESULTS WITH SOME AMAZING FIGURES.

+AND LOOK AT THAT DISCUSSION! FLAWLESS!

 \end{document}
\ No newline at end of file</code></pre>
<p>You can even compare and evaluate the <strong>difference between two any commits</strong> on your repository. In this case I <a href="https://linuxhandbook.com/redirection-linux/">redirected</a> the output of this comparison into an external text file to make it easier to go through the differences!</p>
<pre><code>$ git log --oneline
9740466 (HEAD -&gt; main) modified color and marker size
2d429c5 modified python script
c314709 first commit to start repository

$ git diff 2d429c5 c314709 &gt; diff.txt</code></pre>
<h3 id="reverting-a-mistake">Reverting a mistake</h3>
<p>As mentioned, each commit is a safe checkpoint that “remembers” what each file contained at that moment in your repo. This means that you can go back and forth between commits in case you realize you made mistakes or if you simply want to “undo” some progress due to some reasons. Going back and forth between commits needs to be done with attention and care because it can otherwise lead to permanent changes in the history or files of your repo, that might deeply affect your project, especially if collaborative.</p>
<p>In order to prevent this, in this tutorial we will only cover the case in which you made a mistake in your last commit and you wish to undo it.</p>
<p>Of course, a possibility is always to open the file and modify it back to how it was before the last commit <strong>manually</strong> and make a new commit. But, as you can imagine this is error-prone, you might not remember what you changed and it’s not sustainable for large projects.</p>
<p>So the best way to do so is to use Git revert. In my simple case I realized the change in a formula in my Python script was wrong and it didn’t make sense!</p>
<pre><code>$ git diff HEAD~1
diff --git a/python_script.py b/python_script.py
index 1bd034d..14d4921 100644
--- a/python_script.py
+++ b/python_script.py
@@ -19,7 +19,7 @@ X = np.random.normal(loc = 2, scale = 0.4, size=n)
 error = np.random.normal(loc = 0, scale = 0.1, size=n)
 intercept = 3
 slope = -1
-Y = intercept + X*slope + error
+Y = intercept + X**slope - error</code></pre>
<p>As you can see I elevated X to slope power and I subtracted instead of adding the error. Such a simple mistake could be easily corrected manually but let’s see how to do it with Git revert.</p>
<pre><code>$ git revert HEAD
[main 4ec3686] Revert &quot;updated formula&quot;
 1 file changed, 1 insertion(+), 1 deletion(-)

$ git log --oneline
4ec3686 (HEAD -&gt; main) Revert &quot;updated formula&quot;
2a7f663 updated formula
9740466 modified color and marker size
2d429c5 modified python script
c314709 first commit to start repository</code></pre>
<p>The first line simply “undoes” any modification that was done during the last commit and applies on top of the current version (the HEAD). But in doing so, it creates a new commit so the modification can be easily tracked and nothing is lost.</p>
<h2 id="putting-things-together">Putting things together</h2>
<p>Let’s now say that you have completed the work in each of your sections (abstract, introduction etc..) and you are ready to integrate these features into your main manuscript, to render the final file you will submit to the journal. Keep in mind that as long as you work in independent branches, the main branch won’t have those features, so it’s not time to put things together.</p>
<p>Make sure you are on <strong>the branch you want to merge INTO</strong>. In this case the main branch.</p>
<pre><code>$ git checkout main
Switched to branch &#39;main&#39;

$ git merge manuscript_abstract
Merge made by the &#39;recursive&#39; strategy.
 manuscript.tex | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)</code></pre>
<p>This last command merged all the modifications I made in my abstract branch into the main branch, and the file manuscript.tex file will now contain all the features from the main and the abstract branches!</p>
<h1 id="conclusions">Conclusions</h1>
<p>There is more to learn in the world of Git and Gitlab, but we hope that this was enough to illustrate the usefulness and proper practices of version control.</p>
</body>
</html>
